diff a/src/hotspot/share/opto/partialEscape.hpp b/src/hotspot/share/opto/partialEscape.hpp
--- /dev/null
+++ b/src/hotspot/share/opto/partialEscape.hpp
@@ -0,0 +1,340 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_OPTO_PARTIAL_ESCAPE_HPP
+#define SHARE_OPTO_PARTIAL_ESCAPE_HPP
+
+#include "opto/type.hpp"
+#include "utilities/resourceHash.hpp"
+
+// forward declaration
+class GraphKit;
+
+class ObjectState {
+  friend class PEAState;
+
+  //  ObjectState(const ObjectState&) = delete;
+ protected:
+  int _refcnt = 0;
+  void ref_inc() { _refcnt++; }
+  int ref_dec() { return --_refcnt; }
+  int ref_cnt(int cnt) {
+    int old = _refcnt;
+    _refcnt = cnt;
+    return old;
+  }
+
+ public:
+  inline void* operator new(size_t x) throw() {
+    Compile* C = Compile::current();
+    return C->parser_arena()->AmallocWords(x);
+  }
+
+  virtual bool is_virtual() const = 0;
+  // clone contents but not refcnt;
+  virtual ObjectState* clone() const = 0;
+
+  int ref_cnt() const { return _refcnt; }
+
+  virtual ObjectState& merge(ObjectState* newin, GraphKit* kit, RegionNode* region, int pnum) = 0;
+};
+
+class VirtualState: public ObjectState {
+  friend class PEAState;
+  const TypeOopPtr* const _oop_type;
+  int _lockcnt;
+  Node** _entries;
+
+ protected:
+  VirtualState(const VirtualState& other);
+
+ public:
+  VirtualState(const TypeOopPtr* oop_type);
+
+  bool is_virtual() const override { return true; }
+
+  ObjectState* clone() const override {
+    return new VirtualState(*this);
+  }
+
+  int nfields() const;
+  void set_field(ciField* field, Node* val);
+  Node* get_field(ciField* field) const;
+
+  ObjectState& merge(ObjectState* newin, GraphKit* kit, RegionNode* region, int pnum) override;
+
+  void lock_inc() { _lockcnt++; }
+  void lock_dec() {
+    assert(_lockcnt > 0, "sanity check");
+    --_lockcnt;
+  }
+  int lockcnt() const {
+    return _lockcnt;
+  }
+
+#ifndef PRODUCT
+  void print_on(outputStream* os) const;
+#endif
+
+  class iterator {
+   private:
+    const VirtualState* _state;
+    int _end;
+    int _idx;
+
+   public:
+    iterator(const VirtualState* state): _state(state), _idx(0) {
+      const TypeInstPtr* instptr = _state->_oop_type->isa_instptr();
+      if (instptr != nullptr) {
+        ciInstanceKlass* holder = instptr->instance_klass();
+        _end = holder->nof_nonstatic_fields();
+      } else {
+        _end = 0;
+      }
+    }
+
+    bool has_next() const {
+      return _idx < _end;
+    }
+
+    void operator++() {
+      assert(has_next(), "out of range.");
+      ++_idx;
+    }
+
+    ciField* field() const {
+      assert(_idx < _end, "sanity");
+      ciInstanceKlass* ik = _state->_oop_type->is_instptr()->instance_klass();
+      return ik->nonstatic_field_at(_idx);
+    }
+
+    Node* value() const {
+      assert(_idx < _end, "sanity check");
+      assert(_idx >= 0 && _idx < _state->nfields(), "field is out of range");
+
+      return _state->_entries[_idx];
+    }
+  };
+
+  iterator field_iterator() {
+    return {this};
+  }
+};
+
+class EscapedState: public ObjectState {
+  bool  _materialized; // we may skip passive materialization.
+  Node* _merged_value; // the latest java_oop
+
+ public:
+  EscapedState(bool materialized, Node* value) : _materialized(materialized), _merged_value(value) {}
+
+  bool is_virtual() const override { return false;}
+
+  Node* materialized_value() const {
+    return _materialized ? _merged_value : nullptr;
+  }
+
+  Node* merged_value() const {
+    return _merged_value;
+  }
+
+  bool has_materialized() const {
+    return _materialized;
+  }
+
+  void update(bool materialized, Node* node) {
+    assert(node != nullptr, "assign a nullptr as merged value");
+    assert(materialized || !_materialized, "reverting _materialized is wrong");
+
+    _materialized = materialized;
+    _merged_value = node;
+  }
+
+  void update(Node* node) {
+    update(_materialized, node);
+  }
+
+  ObjectState* clone() const override {
+    return new EscapedState(_materialized, _merged_value);
+  }
+
+  ObjectState& merge(ObjectState* newin, GraphKit* kit, RegionNode* region, int pnum) override {
+    assert(0, "not implemented");
+    return *this;
+  }
+
+#ifndef PRODUCT
+  void print_on(outputStream* os) const;
+#endif
+};
+
+template<typename K, typename V>
+using PEAMap = ResourceHashtable<K, V, 17, /*table_size*/
+                                 AnyObj::C_HEAP, mtCompiler>;
+
+class PartialEscapeAnalysis : public AnyObj {
+  // alias maps from node to ObjID.
+  PEAMap<Node*, ObjID>  _aliases;
+  GrowableArray<ObjID>  _objects;
+
+public:
+  PartialEscapeAnalysis(Arena* arena): _aliases(), _objects(arena, 2, 0, nullptr) {}
+
+  ObjID is_alias(Node* node) const {
+    assert(node != nullptr || !_aliases.contains(node), "_aliases.contain(nullptr) must return false");
+    if (_aliases.contains(node)) {
+      return *(_aliases.get(node));
+    } else {
+      return nullptr;
+    }
+  }
+
+  // refcount is the no. of aliases which refer to the object.
+  // we do garbage collection if refcnt drops to 0.
+  void add_alias(ObjID id, Node* var) {
+    assert(!_aliases.contains(var) || (*_aliases.get(var)) == id, "redefine an alias to another object");
+    if (_aliases.contains(var)) return;
+    _aliases.put(var, id);
+  }
+
+  void remove_alias(ObjID id, Node* var) {
+    assert(_aliases.contains(var) && (*_aliases.get(var)) == id, "sanity check");
+    _aliases.remove(var);
+  }
+
+  // PEA tracks all new instances in the current compilation unit
+  // so we could bisect for bugs.
+  int add_object(ObjID obj) {
+    _objects.push(obj);
+    return _objects.length() - 1;
+  }
+
+  int object_idx(ObjID obj) const {
+    return _objects.find(obj);
+  }
+
+  const GrowableArray<ObjID>& all_objects() const {
+    return _objects;
+  }
+};
+
+//TODO: rename it to allocation state.
+class PEAState {
+  friend class Parse;
+  PEAMap<ObjID, ObjectState*> _state;
+
+ public:
+  PEAState& operator=(const PEAState& init);
+
+  ObjectState* get_object_state(ObjID id) const {
+    assert(contains(id), "object doesn't exist in allocation state");
+    return *(_state.get(id));
+  }
+
+  bool contains(ObjID id) const {
+#ifdef ASSERT
+    if (id == nullptr) {
+      assert(!_state.contains(id), "PEAState must exclude nullptr");
+    }
+#endif
+    return _state.contains(id);
+  }
+
+  Node* get_materialized_value(ObjID id) const;
+
+  Node* get_java_oop(ObjID id) const;
+
+  // Convert the state of obj#id to Escaped.
+  // p is the new alias of obj#id. If materialized is true, the materiazation has taken place in code.
+  // PEA expects to replace all appearances of the object with its java_oop, or materilzied_value().
+  // refer to GraphKit::backfill_materialized.
+  EscapedState* escape(ObjID id, Node* p, bool materialized);
+
+  void add_new_allocation(GraphKit* kit, Node* obj);
+
+  Node* materialize(GraphKit* kit, Node* var);
+
+  void put_field(GraphKit* kit, ciField* field, Node* objx, Node* val);
+
+  int objects(Unique_Node_List& nodes) const;
+  int size() const {
+    return _state.number_of_entries();
+  }
+
+  VirtualState* as_virtual(const PartialEscapeAnalysis* pea, Node* var) const {
+    ObjID id = pea->is_alias(var);
+    if (id != nullptr && contains(id)) {
+      ObjectState* os = get_object_state(id);
+
+      if (os->is_virtual()) {
+        return static_cast<VirtualState*>(os);
+      }
+    }
+    return nullptr;
+  }
+
+  EscapedState* as_escaped(const PartialEscapeAnalysis* pea, Node* var) const {
+    ObjID id = pea->is_alias(var);
+    if (id != nullptr && contains(id)) {
+      ObjectState* os = get_object_state(id);
+
+      if (!os->is_virtual()) {
+        return static_cast<EscapedState*>(os);
+      }
+    }
+    return nullptr;
+  }
+
+  void clear() {
+    _state.unlink_all();
+  }
+
+  // we drop out all virtual objects when we encounter a loop header.
+  void mark_all_escaped(PartialEscapeAnalysis* pea, ObjID id, Node *obj);
+  void mark_all_live_objects_escaped(PartialEscapeAnalysis *pea, SafePointNode* map);
+
+#ifndef PRODUCT
+  void print_on(outputStream* os) const;
+#endif
+
+#ifdef ASSERT
+  void validate() const;
+#endif
+};
+
+class AllocationStateMerger {
+ private:
+  GrowableArray<ObjID> _live; // live objects
+  PEAState& _state;
+  void process_phi(PhiNode* phi, GraphKit* kit, RegionNode* region, int pnum);
+
+ public:
+  AllocationStateMerger(PEAState& target);
+  ~AllocationStateMerger(); // purge all objects which are not in live.
+  void merge(PEAState& newin, GraphKit* kit, RegionNode* region, int pnum);
+  void merge_at_phi_creation(const PartialEscapeAnalysis* pea, PEAState& newin, PhiNode* phi, Node* m, Node* n);
+};
+
+void printPeaStatistics();
+#endif // SHARE_OPTO_PARTIAL_ESCAPE_HPP
diff a/src/hotspot/share/utilities/resourceHash.hpp b/src/hotspot/share/utilities/resourceHash.hpp
--- a/src/hotspot/share/utilities/resourceHash.hpp
+++ b/src/hotspot/share/utilities/resourceHash.hpp
@@ -104,21 +104,11 @@
   ResourceHashtableBase(unsigned size) : STORAGE(size), _number_of_entries(0) {}
   NONCOPYABLE(ResourceHashtableBase);
 
   ~ResourceHashtableBase() {
     if (ALLOC_TYPE == AnyObj::C_HEAP) {
-      Node* const* bucket = table();
-      const unsigned sz = table_size();
-      while (bucket < bucket_at(sz)) {
-        Node* node = *bucket;
-        while (node != nullptr) {
-          Node* cur = node;
-          node = node->_next;
-          delete cur;
-        }
-        ++bucket;
-      }
+      unlink_all();
     }
   }
 
  public:
   unsigned table_size() const { return STORAGE::table_size(); }
@@ -293,12 +283,15 @@
   // called for each entry in the table.  If do_entry() returns true,
   // the entry is deleted.
   template<class ITER>
   void unlink(ITER* iter) {
     const unsigned sz = table_size();
-    for (unsigned index = 0; index < sz; index++) {
+    int cnt = _number_of_entries;
+
+    for (unsigned index = 0; cnt > 0 && index < sz; ++index) {
       Node** ptr = bucket_at(index);
+
       while (*ptr != nullptr) {
         Node* node = *ptr;
         // do_entry must clean up the key and value in Node.
         bool clean = iter->do_entry(node->_key, node->_value);
         if (clean) {
@@ -308,12 +301,42 @@
           }
           _number_of_entries --;
         } else {
           ptr = &(node->_next);
         }
+        if (--cnt <= 0) return;
+      }
+    }
+  }
+
+  // unlink_all() is a specialized version of unlink() when we decide to remove all elements.
+  // It can not replace unlink(ITER* iter) if user-provided iter releases key/value
+  void unlink_all() {
+    Node** bucket = table();
+    const unsigned sz = table_size();
+
+    while (_number_of_entries > 0 && bucket < bucket_at(sz)) {
+      Node* node = *bucket;
+      int n = 0;
+
+      while (node != NULL) {
+        Node* cur = node;
+        node = node->_next;
+        if (ALLOC_TYPE == AnyObj::C_HEAP) {
+          delete cur;
+        }
+        n++;
       }
+
+      if (n > 0) {
+        *bucket = nullptr;
+        _number_of_entries -= n;
+      }
+      bucket++;
     }
+
+    assert(_number_of_entries == 0, "sanity check");
   }
 
   template<typename Function>
   TableStatistics statistics_calculate(Function size_function) const {
     NumberSeq summary;
diff a/test/hotspot/gtest/utilities/test_resourceHash.cpp b/test/hotspot/gtest/utilities/test_resourceHash.cpp
--- a/test/hotspot/gtest/utilities/test_resourceHash.cpp
+++ b/test/hotspot/gtest/utilities/test_resourceHash.cpp
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2015, 2022, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2015, 2023, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -150,11 +150,11 @@
 
       ASSERT_TRUE(rh.remove(as_K(step)));
       ASSERT_FALSE(rh.contains(as_K(step)));
       rh.iterate(&et);
 
-
+      rh.unlink_all();
     }
   };
 };
 
 TEST_VM_F(SmallResourceHashtableTest, default) {
@@ -257,10 +257,16 @@
         ASSERT_TRUE(rh.put(as_K(index), index));
       }
       DeleterTestIter dt(5);
       rh.unlink(&dt);
       ASSERT_FALSE(rh.get(as_K(5)));
+
+      rh.unlink_all();
+      for (uintptr_t i = 10; i > 0; --i) {
+        uintptr_t index = i - 1;
+        ASSERT_FALSE(rh.get(as_K(index)));
+      }
     }
   };
 };
 
 TEST_VM_F(GenericResourceHashtableTest, default) {
@@ -328,10 +334,22 @@
   SimpleDeleter deleter;
   _simple_test_table.unlink(&deleter);
   ASSERT_EQ(s->refcount(), s_orig_count) << "refcount should be same as start";
 }
 
+TEST_VM_F(SimpleResourceHashtableDeleteTest, simle_unlink_all) {
+  TempNewSymbol t = SymbolTable::new_symbol("abcdefg_simple");
+  Symbol* s = t;
+  int s_orig_count = s->refcount();
+  _simple_test_table.put(s, 66);
+  ASSERT_EQ(s->refcount(), s_orig_count + 1) << "refcount should be incremented in table";
+
+  // Use unlink_all to remove the matching (or all) values from the table.
+  _simple_test_table.unlink_all();
+  ASSERT_EQ(s->refcount(), s_orig_count) << "refcount should be same as start";
+}
+
 // More complicated ResourceHashtable with SymbolHandle in the key. Since the *same* Symbol is part
 // of the value, it's not necessary to manipulate the refcount of the key, but you must in the value.
 // Luckily SymbolHandle does this.
 class ResourceHashtableDeleteTest : public ::testing::Test {
  public:
@@ -409,10 +427,25 @@
   ASSERT_EQ(d->refcount(), d_orig_count + 1) << "refcount incremented in table";
   Deleter deleter;
   _test_table.unlink(&deleter);
   ASSERT_EQ(d->refcount(), d_orig_count) << "refcount should be as we started";
 }
+
+TEST_VM_F(ResourceHashtableDeleteTest, value_unlink_all) {
+  TempNewSymbol d = SymbolTable::new_symbol("defghijklmnop");
+  int d_orig_count = d->refcount();
+  {
+    TestValue tv(d);
+    // Same as above, but the do_entry does nothing because the value is deleted when the
+    // hashtable node is deleted.
+    _test_table.put(d, tv);
+    ASSERT_EQ(d->refcount(), d_orig_count + 2) << "refcount incremented by copy";
+  }
+  ASSERT_EQ(d->refcount(), d_orig_count + 1) << "refcount incremented in table";
+  _test_table.unlink_all();
+  ASSERT_EQ(d->refcount(), d_orig_count) << "refcount should be as we started";
+}
 
 TEST_VM_F(ResourceHashtableDeleteTest, check_delete_ptr) {
   TempNewSymbol s = SymbolTable::new_symbol("abcdefg_ptr");
   int s_orig_count = s->refcount();
   {
diff a/test/hotspot/jtreg/compiler/c2/irTests/blackhole/BlackholeSyncEATest.java b/test/hotspot/jtreg/compiler/c2/irTests/blackhole/BlackholeSyncEATest.java
--- a/test/hotspot/jtreg/compiler/c2/irTests/blackhole/BlackholeSyncEATest.java
+++ b/test/hotspot/jtreg/compiler/c2/irTests/blackhole/BlackholeSyncEATest.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2022, Red Hat, Inc. All rights reserved.
+ * Copyright (c) 2022, 2024 Red Hat, Inc. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -36,12 +36,14 @@
 import jdk.test.lib.Asserts;
 
 public class BlackholeSyncEATest {
 
     public static void main(String[] args) {
+        // Turn off PEA or it will elide the lock of synchronized (o){} before escaping.
         TestFramework.runWithFlags(
             "-XX:+UnlockExperimentalVMOptions",
+            "-XX:-DoPartialEscapeAnalysis",
             "-XX:CompileCommand=blackhole,compiler.c2.irTests.blackhole.BlackholeSyncEATest::blackhole",
             "-XX:CompileCommand=dontinline,compiler.c2.irTests.blackhole.BlackholeSyncEATest::dontinline"
         );
     }
 
diff a/test/micro/org/openjdk/bench/vm/compiler/pea/HashMapBench.java b/test/micro/org/openjdk/bench/vm/compiler/pea/HashMapBench.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/vm/compiler/pea/HashMapBench.java
@@ -0,0 +1,103 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package org.openjdk.bench.vm.compiler.pea;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.Param;
+import org.openjdk.jmh.annotations.Setup;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+import java.util.ArrayList;
+import java.util.HashMap;
+
+@BenchmarkMode(Mode.AverageTime)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
+@Measurement(iterations = 10, time = 1, timeUnit = TimeUnit.SECONDS)
+@State(Scope.Benchmark)
+@Fork(value = 3)
+public class HashMapBench {
+    class Key {
+        int x;
+        Key(int x) { this.x = x; }
+        public int hashCode() { return x; }
+        public boolean equals(Object other) { return this.hashCode() == other.hashCode(); }
+    }
+
+    static void blackhole(Object o) {}
+
+    @Param("1024")
+    private int size;
+
+    @Param({"1", "2", "4"})
+    private int fillInterval;
+
+    ArrayList<Key> keys;
+    HashMap<Key, Object> map;
+
+    @Setup
+    public void setUp() {
+        keys = new ArrayList<>();
+        map = new HashMap<>();
+        for (int i = 0; i < size; ++i) {
+            keys.add(new Key(i));
+            if (i % fillInterval == 0) {
+                map.put(new Key(i), new Object());
+            }
+        }
+    }
+
+    @Benchmark
+    public void replace() {
+        for (int i = 0; i < size; ++i) {
+            map.replace(keys.get(i), new Object());
+        }
+    }
+
+    @Benchmark
+    public void computeIfAbsent() {
+        for (int i = 0; i < size; ++i) {
+            map.computeIfAbsent(new Key(i), key -> new Object());
+        }
+    }
+
+    @Benchmark
+    public void cacheUpdate() {
+        for (int i = 0; i < size; ++i) {
+            Key key = new Key(i);
+            if (!map.containsKey(key)) {
+                map.put(key, new Object());
+            }
+        }
+    }
+}
+
diff a/test/micro/org/openjdk/bench/vm/compiler/pea/Simple.java b/test/micro/org/openjdk/bench/vm/compiler/pea/Simple.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/vm/compiler/pea/Simple.java
@@ -0,0 +1,80 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.vm.compiler.pea;
+
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.BenchmarkMode;
+import org.openjdk.jmh.annotations.CompilerControl;
+import org.openjdk.jmh.annotations.Fork;
+import org.openjdk.jmh.annotations.Measurement;
+import org.openjdk.jmh.annotations.Mode;
+import org.openjdk.jmh.annotations.Param;
+import org.openjdk.jmh.annotations.Scope;
+import org.openjdk.jmh.annotations.State;
+import org.openjdk.jmh.annotations.OutputTimeUnit;
+import org.openjdk.jmh.annotations.Warmup;
+
+import java.util.concurrent.TimeUnit;
+
+@BenchmarkMode(Mode.AverageTime)
+@OutputTimeUnit(TimeUnit.NANOSECONDS)
+@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
+@Measurement(iterations = 20, time = 1, timeUnit = TimeUnit.SECONDS)
+@State(Scope.Benchmark)
+@Fork(value = 3)
+public class Simple {
+    @Param({"1", "2", "4", "8"})
+    int odd;
+    private Object _cache;
+
+    void example1(boolean cond) {
+        Object x = new Object();
+        if (cond) {
+            _cache = x;
+        }
+    }
+
+    @Benchmark
+    public void example1() {
+        for (int i = 0; i< 1024; ++i) {
+            boolean cond = (i % odd) == 0;
+            example1(cond);
+        }
+    }
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    static void escaped_as_argument(Object x) {}
+
+    // Ivanov suggests making this happen first.
+    // we don't need to create JVMState for the cloning Allocate.
+    @Benchmark
+    public void example1_ArgEscape() {
+        for (int i = 0; i< 1024; ++i) {
+            boolean cond = (i % odd) == 0;
+            Object x = new Object();
+
+            if (cond) {
+                escaped_as_argument(x);
+            }
+        }
+    }
+}
